#include "lcd_init.h"
//#include "delay.h"
#include <rtthread.h>
#include <rtdevice.h>
#include <stdint.h>
#include <n32g45x.h>
#include "drv_gpio.h"
#include "rtconfig.h"
/***************************************************************************
//         : 
//     : 2023-1-30
//  ޸   :
//     :N32G45 st7735
//              ˵:
//              ----------------------------------------------------------------
//              GND   Դ
//              VCC   3.3vԴ
#define RES_PIN  36  //PC4   33
#define DC_PIN   37  //PC5   34
#define BLK_PIN  16  //PB0   35
#define SCK_PIN  5  //PA5
#define MOSI_PIN 7  //PA7
#define CS_PIN   4  //PA4
//              ----------------------------------------------------------------
// ޸ʷ   :
//        :
//All rights reserved
//******************************************************************************/

#define SPI1_BUS_NAME         "spi1"
#define SPI1__DEVICE_NAME     "spi10"

//#define SPI1_NCS_PIN 4


struct n32_hw_spi_cs
{
    GPIO_Module* GPIOx;
    uint32_t GPIO_Pin;
};

struct rt_spi_device *st7753_spi_dev;

int rt_hw_spi_config(void)
{
    static struct n32_hw_spi_cs  spi_cs1;
    static struct rt_spi_device spi_dev_1 ;
    rt_err_t res;
    spi_cs1.GPIO_Pin = CS_PIN;
    spi_cs1.GPIOx = GPIOA;
    rt_pin_mode(CS_PIN, PIN_MODE_OUTPUT);
    res = rt_spi_bus_attach_device(&spi_dev_1, SPI1__DEVICE_NAME, SPI1_BUS_NAME, (void*)&spi_cs1);
    if (res != RT_EOK)
    {
        rt_kprintf("rt_spi_bus_attach_device!\r\n");
        return res;
    }
    spi_dev_1.bus->owner = &spi_dev_1;
    {
        struct rt_spi_configuration cfg;
        cfg.data_width = 8;
        cfg.mode =   RT_SPI_MODE_3 | RT_SPI_MSB ;
        cfg.max_hz = 40*1000 *1000; /* 40M,SPI max 42MHz, 3-wire spi */
        if(spi_dev_1.bus->owner==RT_NULL)
        {
            rt_kprintf("RT_OK\r\n");
        }
        rt_kprintf("owner= %d\r\n",*spi_dev_1.bus->owner);
        res = rt_spi_configure(&spi_dev_1, &(cfg));
        if(res != RT_EOK)
        {
            rt_kprintf("configure spi1 ERR!\r\n");
        }

    }
    st7753_spi_dev = (struct rt_spi_device *)rt_device_find(SPI1__DEVICE_NAME);
        if(!&st7753_spi_dev)
        {
            rt_kprintf("spi1 test run failed! can't find %s device!\n", SPI1__DEVICE_NAME);
        }
    return RT_EOK;
}

INIT_DEVICE_EXPORT(rt_hw_spi_config);
/*  ST7735GPIOʼ   */
void LCD_GPIO_Init(void)
{
    rt_pin_mode(RES_PIN, PIN_MODE_OUTPUT);
    rt_pin_mode(DC_PIN, PIN_MODE_OUTPUT);
    rt_pin_mode(BLK_PIN, PIN_MODE_OUTPUT);
    rt_pin_mode(CS_PIN, PIN_MODE_OUTPUT);
}


/******************************************************************************
      ˵LCDд뺯
      ݣdat  ҪдĴ
      ֵ  
******************************************************************************/
void LCD_Writ_Bus(uint8_t dat)
{
    rt_spi_send(st7753_spi_dev, &dat, 1);
}


/******************************************************************************
      ˵LCDд
      ݣdat д
      ֵ  
******************************************************************************/
void LCD_WR_DATA8(uint8_t dat)
{
	LCD_Writ_Bus(dat);
}


/******************************************************************************
      ˵LCDд
      ݣdat д
      ֵ  
******************************************************************************/
void LCD_WR_DATA(uint16_t dat)
{
	LCD_Writ_Bus(dat>>8);
	LCD_Writ_Bus(dat);
}


/******************************************************************************
      ˵LCDд
      ݣdat д
      ֵ  
******************************************************************************/
void LCD_WR_REG(uint8_t dat)
{
	LCD_DC_Clr();//д
	LCD_Writ_Bus(dat);
	LCD_DC_Set();//д
}


/******************************************************************************
      ˵ʼͽַ
      ݣx1,x2 еʼͽַ
                y1,y2 еʼͽַ
      ֵ  
******************************************************************************/
void LCD_Address_Set(uint16_t x1,uint16_t y1,uint16_t x2,uint16_t y2)
{
	if(USE_HORIZONTAL==0)
	{
		LCD_WR_REG(0x2a);//еַ
		LCD_WR_DATA(x1+2);
		LCD_WR_DATA(x2+2);
		LCD_WR_REG(0x2b);//еַ
		LCD_WR_DATA(y1+1);
		LCD_WR_DATA(y2+1);
		LCD_WR_REG(0x2c);//д
	}
	else if(USE_HORIZONTAL==1)
	{
		LCD_WR_REG(0x2a);//еַ
		LCD_WR_DATA(x1+2);
		LCD_WR_DATA(x2+2);
		LCD_WR_REG(0x2b);//еַ
		LCD_WR_DATA(y1+1);
		LCD_WR_DATA(y2+1);
		LCD_WR_REG(0x2c);//д
	}
	else if(USE_HORIZONTAL==2)
	{
		LCD_WR_REG(0x2a);//еַ
		LCD_WR_DATA(x1+1);
		LCD_WR_DATA(x2+1);
		LCD_WR_REG(0x2b);//еַ
		LCD_WR_DATA(y1+2);
		LCD_WR_DATA(y2+2);
		LCD_WR_REG(0x2c);//д
	}
	else
	{
		LCD_WR_REG(0x2a);//еַ
		LCD_WR_DATA(x1+1);
		LCD_WR_DATA(x2+1);
		LCD_WR_REG(0x2b);//еַ
		LCD_WR_DATA(y1+2);
		LCD_WR_DATA(y2+2);
		LCD_WR_REG(0x2c);//д
	}
}

void LCD_Init(void)
{
	LCD_GPIO_Init();//ʼGPIO
	
	LCD_RES_Clr();//λ
	rt_thread_mdelay(100);
	LCD_RES_Set();
	rt_thread_mdelay(100);
	
	LCD_BLK_Set();//򿪱
  rt_thread_mdelay(100);
	
	//************* Start Initial Sequence **********//
	LCD_WR_REG(0x11); //Sleep out 
	rt_thread_mdelay(120);              //Delay 120ms
	//------------------------------------ST7735S Frame Rate-----------------------------------------// 
	LCD_WR_REG(0xB1); 
	LCD_WR_DATA8(0x05); 
	LCD_WR_DATA8(0x3C); 
	LCD_WR_DATA8(0x3C); 
	LCD_WR_REG(0xB2); 
	LCD_WR_DATA8(0x05);
	LCD_WR_DATA8(0x3C); 
	LCD_WR_DATA8(0x3C); 
	LCD_WR_REG(0xB3); 
	LCD_WR_DATA8(0x05); 
	LCD_WR_DATA8(0x3C); 
	LCD_WR_DATA8(0x3C); 
	LCD_WR_DATA8(0x05); 
	LCD_WR_DATA8(0x3C); 
	LCD_WR_DATA8(0x3C); 
	//------------------------------------End ST7735S Frame Rate---------------------------------// 
	LCD_WR_REG(0xB4); //Dot inversion 
	LCD_WR_DATA8(0x03); 
	//------------------------------------ST7735S Power Sequence---------------------------------// 
	LCD_WR_REG(0xC0); 
	LCD_WR_DATA8(0x28); 
	LCD_WR_DATA8(0x08); 
	LCD_WR_DATA8(0x04); 
	LCD_WR_REG(0xC1); 
	LCD_WR_DATA8(0XC0); 
	LCD_WR_REG(0xC2); 
	LCD_WR_DATA8(0x0D); 
	LCD_WR_DATA8(0x00); 
	LCD_WR_REG(0xC3); 
	LCD_WR_DATA8(0x8D); 
	LCD_WR_DATA8(0x2A); 
	LCD_WR_REG(0xC4); 
	LCD_WR_DATA8(0x8D); 
	LCD_WR_DATA8(0xEE); 
	//---------------------------------End ST7735S Power Sequence-------------------------------------// 
	LCD_WR_REG(0xC5); //VCOM 
	LCD_WR_DATA8(0x1A); 
	LCD_WR_REG(0x36); //MX, MY, RGB mode 
	if(USE_HORIZONTAL==0)LCD_WR_DATA8(0x00);
	else if(USE_HORIZONTAL==1)LCD_WR_DATA8(0xC0);
	else if(USE_HORIZONTAL==2)LCD_WR_DATA8(0x70);
	else LCD_WR_DATA8(0xA0); 
	//------------------------------------ST7735S Gamma Sequence---------------------------------// 
	LCD_WR_REG(0xE0); 
	LCD_WR_DATA8(0x04); 
	LCD_WR_DATA8(0x22); 
	LCD_WR_DATA8(0x07); 
	LCD_WR_DATA8(0x0A); 
	LCD_WR_DATA8(0x2E); 
	LCD_WR_DATA8(0x30); 
	LCD_WR_DATA8(0x25); 
	LCD_WR_DATA8(0x2A); 
	LCD_WR_DATA8(0x28); 
	LCD_WR_DATA8(0x26); 
	LCD_WR_DATA8(0x2E); 
	LCD_WR_DATA8(0x3A); 
	LCD_WR_DATA8(0x00); 
	LCD_WR_DATA8(0x01); 
	LCD_WR_DATA8(0x03); 
	LCD_WR_DATA8(0x13); 
	LCD_WR_REG(0xE1); 
	LCD_WR_DATA8(0x04); 
	LCD_WR_DATA8(0x16); 
	LCD_WR_DATA8(0x06); 
	LCD_WR_DATA8(0x0D); 
	LCD_WR_DATA8(0x2D); 
	LCD_WR_DATA8(0x26); 
	LCD_WR_DATA8(0x23); 
	LCD_WR_DATA8(0x27); 
	LCD_WR_DATA8(0x27); 
	LCD_WR_DATA8(0x25); 
	LCD_WR_DATA8(0x2D); 
	LCD_WR_DATA8(0x3B); 
	LCD_WR_DATA8(0x00); 
	LCD_WR_DATA8(0x01); 
	LCD_WR_DATA8(0x04); 
	LCD_WR_DATA8(0x13); 
	//------------------------------------End ST7735S Gamma Sequence-----------------------------// 
	LCD_WR_REG(0x3A); //65k mode 
	LCD_WR_DATA8(0x05); 
	LCD_WR_REG(0x29); //Display on 
} 







