#ifndef __LCD_INIT_H
#define __LCD_INIT_H

#include <rtthread.h>
#include <stdint.h>

#define USE_HORIZONTAL 1  //úʾ 01Ϊ 23Ϊ


#if USE_HORIZONTAL==0||USE_HORIZONTAL==1
#define LCD_W 128
#define LCD_H 160

#else
#define LCD_W 160
#define LCD_H 128
#endif


#define RES_PIN  36  //PC4   33
#define DC_PIN   37  //PC5   34
#define BLK_PIN  16  //PB0   35
#define SCK_PIN  5  //PA5
#define MOSI_PIN 7  //PA7
#define CS_PIN   4  //PA4



//-----------------LCD˿ڶ----------------
#define SPIy          SPI1
#define SPIy_CLK      RCC_APB2_PERIPH_SPI1
#define SPIy_GPIO     GPIOA
#define SPIy_GPIO_CLK RCC_APB2_PERIPH_GPIOA
#define SPIy_PIN_SCK  GPIO_PIN_5
#define SPIy_PIN_MISO GPIO_PIN_6
#define SPIy_PIN_MOSI GPIO_PIN_7

#define SYSCLK_PLLHSI_FREQ_24MHz

#define LCD_SCLK_Clr() rt_pin_write(SCK_PIN, PIN_LOW)//SCL=SCLK
#define LCD_SCLK_Set() rt_pin_write(SCK_PIN, PIN_HIGH)

#define LCD_MOSI_Clr() rt_pin_write(MOSI_PIN, PIN_LOW)//SDA=MOSI
#define LCD_MOSI_Set() rt_pin_write(MOSI_PIN, PIN_HIGH)

#define LCD_CS_Clr()   rt_pin_write(CS_PIN, PIN_LOW)//CS
#define LCD_CS_Set()   rt_pin_write(CS_PIN, PIN_HIGH)

#define LCD_RES_Clr()  rt_pin_write(RES_PIN, PIN_LOW)//RES
#define LCD_RES_Set()  rt_pin_write(RES_PIN, PIN_HIGH)

#define LCD_DC_Clr()   rt_pin_write(DC_PIN, PIN_LOW)//DC
#define LCD_DC_Set()   rt_pin_write(DC_PIN, PIN_HIGH)

#define LCD_BLK_Clr()  rt_pin_write(BLK_PIN, PIN_LOW)//BLK
#define LCD_BLK_Set()  rt_pin_write(BLK_PIN, PIN_HIGH)




void LCD_GPIO_Init(void);//ʼGPIO
void LCD_Writ_Bus(uint8_t dat);//ģSPIʱ
void LCD_WR_DATA8(uint8_t dat);//дһֽ
void LCD_WR_DATA(uint16_t dat);//дֽ
void LCD_WR_REG(uint8_t dat);//дһָ
void LCD_Address_Set(uint16_t x1,uint16_t y1,uint16_t x2,uint16_t y2);//꺯
void LCD_Init(void);//LCDʼ
#endif




